#include "main.h"

Worker worker;
static HANDLE hCom;

// 1 Byte schreiben, 1 Byte lesen (optional)
// Liefert negativen Wert bei Fehler, sonst 0 (r=false) oder gelesenes Byte
// Bei w == 191 == 0xBF kommt die Antwort "100" ber 100 ms spter:
// Vermutlich ist dies das Kommando zum Flashen der Parameter
static int com_wr(BYTE a=100) {
 OVERLAPPED o;
 ZeroMemory(&o,sizeof o);
 DWORD bw;
 if (!WriteFile(hCom,&a,1,&bw,&o)) {
  if (GetLastError()==ERROR_IO_PENDING
  && !WaitForSingleObject(hCom,100)) {	// Faktisch kein Timeout
   GetOverlappedResult(hCom,&o,&bw,FALSE);
  }else{
   CancelIo(hCom);
   return -1;	// Timeout beim Senden (sollte nie passieren)
  }
 }
 if (bw!=1) return -2;	// Unrichtige Byte-Anzahl beim Senden (sollte nie passieren)
 if (!ReadFile(hCom,&a,1,&bw,&o)) {
  if (GetLastError()==ERROR_IO_PENDING
  && !WaitForSingleObject(hCom,200)) {	// Timeout bei 200 ms
   GetOverlappedResult(hCom,&o,&bw,FALSE);
  }else{
   CancelIo(hCom);
   return -3;	// Timeout beim Lesen
  }
 }
 if (bw!=1) return -4;	// Unrichtige Byte-Anzahl beim Empfang
// PurgeComm(hCom,PURGE_RXCLEAR|PURGE_TXCLEAR);
 return a;
}

// 1 Byte schreiben, 1 Byte lesen, in 2 Versuchen
// Bei Timeout im 1. Versuch Schreiben wiederholen
// (Sieht so aus, als ob das Protokoll so gemacht ist.)
static int comGetByte(BYTE a=100) {
 int r=com_wr(a);
 if (r<0) debug((TEXT("com_wr() mit Fehler Kode %d\n"),r));
 if (r==-3 || r==-4) r=com_wr(a);	// 2. Versuch
 assert(r>=0);
 return r;
}

// 2-Byte-Wert lesen, jedes Byte in 2 Versuchen
static int comGetWord(BYTE a=100) {
 int h=comGetByte(a);	// High-Teil
 if (h<0) return h;
 int l=comGetByte();	// Low-Teil
 if (l<0) return l;
 return h<<8|l;
}

// Beim Schreiben ist Bit 7 der Adresse gesetzt,
// und die Antwort fr "OK" muss "100" lauten.
static int comSetByte(BYTE a,int v) {
 int r=comGetByte(a|0x80);
 if (r!=100) return r;
 return comGetByte(LOBYTE(v));
}

static int comSetWord(BYTE a,int v) {
 int r=comGetByte(a|0x80);
 if (r!=100) return r;
 r=comGetByte(HIBYTE(v));
 if (r!=100) return r;
 return comGetByte(LOBYTE(v));
}

struct V{
 BYTE anz8,anz16;	// Anzahl der 8- und 16-Bit-Werte
 BYTE size() const {return anz8+anz16;}
 int read(BYTE idx,BYTE start);
 bool write(BYTE start,BYTE idx);	// nur fr Parameter, nicht fr Werte
 static bool flush();			// nur fr Parameter, nicht fr Werte
}params,values;


int V::read(BYTE idx,BYTE start) {
 return (idx<anz8 ? comGetByte : comGetWord)(start+idx);	// Parameter lesen
}

// Spalte 0 zu Multi_Sz zusammenfassen und Zeiger auf Listenende liefern
TCHAR*lvCollectStrings(HWND lv,TCHAR*buf,const TCHAR*e) {
 int k=ListView_GetItemCount(lv);
 for (int i=0; i<k; i++) {
  ListView_GetItemText(lv,i,0,buf,int(e-buf));
  if (!*buf) {*buf++='A'+i; *buf=0;}	// Leere Strings sind nicht erlaubt!
  buf+=lstrlen(buf)+1;
 }
 return buf;
}

static void comClose() {
 KillTimer(hMainWnd,4);
 TCHAR s[64];
 if (GetDlgItemText(hMainWnd,13,s,elemof(s))) {
  const TCHAR*e=listcaptions+elemof(listcaptions);
  *lvCollectStrings(GetDlgItem(hMainWnd,12),lvCollectStrings(GetDlgItem(hMainWnd,11),listcaptions,e),e)=0;
  config.save(s);
 }
// if (o.hEvent) CloseHandle(o.hEvent);
 if (hCom) CloseHandle(hCom);
 SetDlgItemText(hMainWnd,13,0);
 SendDlgItemMessage(hMainWnd,11,LVM_DELETEALLITEMS,0,0);
 SendDlgItemMessage(hMainWnd,12,LVM_DELETEALLITEMS,0,0);
}

// ListView mit der vorgefundenen Anzahl Werte initialisieren
static const TCHAR*lvSetCount(HWND lv,int count,const TCHAR*captions) {
 ListView_DeleteAllItems(lv);
 LVITEM item;
 item.mask=LVIF_TEXT;;
 item.iSubItem=0;
 for (item.iItem=0; item.iItem<count; item.iItem++) {
  if (*captions) {
   item.pszText=const_cast<TCHAR*>(captions);
   captions+=lstrlen(captions)+1;	// vorrcken
  }else{
   TCHAR s[16];
   item.pszText=s;
   _sntprintf(s,elemof(s),TEXT("%u"),item.iItem+1);
  }
  ListView_InsertItem(lv,&item);
 }
// item.iSubItem=1;
// item.pszText=TEXT("?");
// for (item.iItem=0; item.iItem<count; item.iItem++) {
//  ListView_SetItem(lv,&item);
// }
 return captions;
}

static void lvSetValue(HWND lv,int x, int y, int v) {
 TCHAR s[16];
 LVITEM item;
 item.mask=LVIF_TEXT;
 item.pszText=s;
 item.iItem=y;
 item.iSubItem=x;
 if (v>=0) _sntprintf(s,elemof(s),TEXT("%u"),v);// aktualisieren
 else _sntprintf(s,elemof(s),TEXT("?"));	// Fragezeichen anzeigen
// if (!WaitForSingleObject(worker.hStop,0)) return;
 ListView_SetItem(lv,&item);
}

DWORD Worker::ThreadProc() {
 TCHAR comname[16];
 _sntprintf(comname,elemof(comname),TEXT("\\\\.\\COM%u"),config.comnr+1);
 hCom=CreateFile(comname,GENERIC_READ|GENERIC_WRITE,
   0,0,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,0);
 if (hCom==INVALID_HANDLE_VALUE) hCom=0;
 if (!hCom) {
  debug((TEXT("Fehler beim ffnen von %s, Kode %d\n"),comname,GetLastError()));
  return 0;				// Abbruch durch Problem beim ffnen der Schnittstelle
 }
// o.hEvent=CreateEvent(0,FALSE,FALSE,0);
 DCB dcb;
 dcb.DCBlength=sizeof dcb;
 GetCommState(hCom,&dcb);
 dcb.BaudRate=4800;
 dcb.ByteSize=8;
 dcb.fParity=1;
 dcb.fOutxCtsFlow=0;
 dcb.fOutxDsrFlow=0;
 dcb.fDsrSensitivity=0;
 dcb.fInX=0;
 dcb.fOutX=0;
 dcb.Parity=EVENPARITY;
 dcb.StopBits=ONESTOPBIT;
 SetCommState(hCom,&dcb);
 static const COMMTIMEOUTS to={0,0,0,0,0};	// keine Timeouts, sondern OverlappedIO
 SetCommTimeouts(hCom,const_cast<COMMTIMEOUTS*>(&to));

 if (!WaitForSingleObject(hStop,0)) return 3;	// Abbruch durch stop()

 if (comGetByte(0xD6)==0xDA) {
  comGetByte(2);		// Anfordern Gertebeschreibung, Antwort 'B' ignorieren
  int l=comGetByte();	// Lnge Datenblock (hier: 11)
  if (l>1 && l<31) {
   TCHAR s[32];
   s[l]=0;		// terminieren (1)
   for(BYTE i=0;i<l;i++) s[i]=comGetByte();
   if (s[0]<32) s[1+s[0]]=0;	// terminieren (2)
   SetDlgItemText(hMainWnd,13,s);
   config.load(s);
  }
 }else{
  MessageBeep(MB_ICONEXCLAMATION);
  return 4;
 }

 if (!WaitForSingleObject(hStop,0)) return 3;	// Abbruch durch stop()

// Um zu sehen, wie langsam die Daten angekleckert kommen, zeitnah die ListViews fllen
 HWND hParams=GetDlgItem(hMainWnd,11),
      hValues=GetDlgItem(hMainWnd,12);
 params.anz8=comGetByte(1);
 params.anz16=comGetByte(1);
 const TCHAR*p=lvSetCount(hParams,params.size(),listcaptions);
 values.anz8=comGetByte(1);
 values.anz16=comGetByte(1);
 lvSetCount(hValues,values.size(),p);
 comGetByte(1);		// da kommt eine 0x01, ignorieren
 BYTE i;
 for (i=0; i<params.anz8; i++) {
  lvSetValue(hParams,2,i,comGetByte());	// 8-Bit-Minima
 }
 for (i=0; i<params.anz8; i++) {
  lvSetValue(hParams,3,i,comGetByte());	// 8-Bit-Maxima
 }
 for (i=0; i<params.anz16; i++) {
  lvSetValue(hParams,2,params.anz8+i,comGetWord());// 16-Bit-Minima
 }
 for (i=0; i<params.anz16; i++) {
  lvSetValue(hParams,3,params.anz8+i,comGetWord());// 16-Bit-Maxima
 }

 for (i=0; i<params.size(); i++) {
  if (!WaitForSingleObject(hStop,0)) return 3;	// Abbruch durch stop()
  lvSetValue(hParams,1,i,params.read(i,0));
 }

 for(;;) {
  for (i=0; i<values.size(); i++) {
   if (!WaitForSingleObject(hStop,0)) return 3;	// Abbruch durch stop()
   lvSetValue(hValues,1,i,values.read(i,45));
  }
 }
}

DWORD CALLBACK Worker::ThreadProc(void*p) {
 return ((Worker*)p)->ThreadProc();
}

bool Worker::start() {
 hStop=CreateEvent(0,TRUE,FALSE,NULL);
 hThread=CreateThread(0,0,ThreadProc,this,0,&threadId);
 return true;
}

bool Worker::stop() {
 SetEvent(hStop);
 MsgWaitForMultipleObjects(1,&hThread,FALSE,INFINITE,QS_ALLEVENTS);	// damit hngt's nicht beim ListView-Update (warum auch immer!)
 //WaitForSingleObject(hThread,INFINITE)	// hngt inmitten ListView-Update
 CloseHandle(hThread);
 CloseHandle(hStop);
 comClose();
 return true;
}
